<?php

/**
 * Namespace
 */
namespace CreoCode\ContaoFormSubmissions\Classes;
use Contao\Database;

use CreoCode\ContaoFormSubmissions\FormSubmissionsSetModel;
use CreoCode\ContaoFormSubmissions\FormSubmissions;


class Statistics extends \BackendModule {

    /**
     * Template
     * @var string
     */
    protected $strTemplate = 'form_submissions_statistics';

    /**
     * Generate the module
     */
    protected function compile() {

        $strOptions = '';
        $arrForms = FormSubmissionsSetModel::findAll();

        if (!$arrForms) {
            $this->Template->statisticNotAvailable = true;
        } else {
            $strOptions .= '<option value="showAll">Alle</option>';
            foreach ($arrForms as $form) {
                $strOptions .= sprintf('<option value="%s">%s</option>', $form->id, $form->form_title);
            }

            $this->Template->options = $strOptions;
            $this->Template->base = \Environment::get('base');
            $this->Template->href = (\Input::post('FORM_SUBMIT') == 'tl_labels') ? \Environment::get('request') : $this->getReferer(true);
            $this->Template->action = ampersand(\Environment::get('request'));
            $this->Template->warning = $GLOBALS['TL_LANG']['tl_labels']['warning'];
            $this->Template->error = $GLOBALS['TL_LANG']['tl_labels']['error'];
            $this->Template->ok = $GLOBALS['TL_LANG']['tl_labels']['ok'];


            // Find missing labels
            if (\Input::get('form_set') && \Input::get('view') && \Input::get('start') && \Input::get('end')) {
                $this->Template->view = \Input::get('view');
                $formSetId = \Input::get('form_set');
                $startDate = \Input::get('start');
                $endDate = \Input::get('end');

                $wheres = array();
                $where = '';
                if ($startDate) {
                    $wheres[] = "tstamp > " . strtotime($startDate);
                }
                if ($endDate) {
                    $wheres[] = "tstamp < " . strtotime($endDate);
                }
                if (!empty($wheres)) {
                    $where = 'WHERE '. implode(' AND ', $wheres);
                }

                $this->Template->searchMode = true;
                $this->Template->startDate = $startDate;
                $this->Template->endDate = $endDate;

                if ($formSetId == 'showAll') {
                    $this->Template->objFormData = $this->Database->prepare("SELECT id,tstamp FROM tl_form_submissions $where")
                            ->execute()->fetchAllAssoc();
                } else {
                    $this->Template->objFormData = $this->Database->prepare("SELECT id,tstamp FROM tl_form_submissions $where AND pid=?")
                            ->execute($formSetId)->fetchAllAssoc();
                }
            }


            // add chart.js library
            $GLOBALS['TL_JAVASCRIPT'][] = 'bundles/contaoformsubmissions/vendor/chartjs/Chart.bundle' .(\System::getContainer()->get('kernel')->isDebug()?'':'.min'). '.js';
        }

    }

}